=== modified file 'NEWS'
--- NEWS	2008-04-04 02:34:56 +0000
+++ NEWS	2008-04-25 19:41:23 +0000
@@ -26,6 +26,8 @@
 
   * Added enable/disable per-branch option (Martin Albisetti)
 
+  * Add compare with option to revisions menu. (Javier Derderian)
+
  BUG FIXES
 
   * Make adding tags from the viz work again. (Daniel Schierbeck)

=== modified file 'revbrowser.py'
--- revbrowser.py	2008-02-14 19:59:06 +0000
+++ revbrowser.py	2008-04-25 19:41:23 +0000
@@ -42,7 +42,8 @@
         
         # Create the widgets
         self._button_select = gtk.Button(_("_Select"), use_underline=True)
-        self.treeview = TreeView(branch,branch.last_revision(), None)
+        start_revs = [branch.last_revision(),]
+        self.treeview = TreeView(branch, start_revs, None)
         
         # Set callbacks
         self._button_select.connect('clicked', self._on_select_clicked)

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-04-23 15:19:14 +0000
+++ viz/branchwin.py	2008-04-25 19:41:23 +0000
@@ -196,12 +196,17 @@
         revision_menu_diff = gtk.MenuItem("View Changes")
         revision_menu_diff.connect('activate', 
                 lambda w: self.treeview.show_diff())
-
+        
+        revision_menu_compare = gtk.MenuItem("Compare with...")
+        revision_menu_compare.connect('activate',
+                self._compare_with_cb)
+        
         revision_menu_tag = gtk.MenuItem("Tag Revision")
         revision_menu_tag.connect('activate', self._tag_revision_cb)
 
         revision_menu.add(revision_menu_tag)
         revision_menu.add(revision_menu_diff)
+        revision_menu.add(revision_menu_compare)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -378,6 +383,22 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
+    def _compare_with_cb(self,w):
+        """Callback for revision 'compare with' menu. Will show a small
+            dialog with branch revisions to compare with selected revision in TreeView"""
+        
+        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
+        
+        rb = RevisionBrowser(self.branch,self)
+        ret = rb.run()
+        
+        if ret == gtk.RESPONSE_OK:          
+            (path, focus) = self.treeview.treeview.get_cursor()
+            revid = self.treeview.model[path][treemodel.REVID]
+            self.show_diff(revid, rb.selected_revid)
+            
+        rb.destroy()
+            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 

